#!/usr/bin/perl
#!/usr/bin/perl -I/directory/where/preinit.pm/file/is/located
# indexsoft Site-UP
# (c) indexsoft 2001-2004
# http://www.indexsoft.com

eval ('require "preinit.pm";');
print qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\nPragma: no-cache\nCache-Control: no-cache\n\n<script>top.location='index.cgi'</script>} if $@;

eval('require "$CONFIGFILE";');
$cfgerror = $@ if $@;
if ($cfgerror or !$SKINSSUBDIR)
{
	$SKINSSUBDIR = 'skins\english';
	$SKINSEXT = '.html';
	$SKINSINMEM = '0';
}
require "subrouts.pm";
require "initvars.pm";

print qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\nPragma: no-cache\nCache-Control: no-cache\n\n};
if ($skinerror) { print $skinerror; exit; }

$QUOTEBY = 'qq';
$JOINMULTIPLEBY = ',';
$CONFIGINIT = "$SKINSDIR$DIRSEPARATOR".'config.ini';

if ($P{icfg_cfginit} and $P{icfg_cfgfile} and $P{icfg_cfgfile} ne $CONFIGFILE and $P{icfg_cfginit} ne $CONFIGINIT)
{
	$CONFIGINIT = $P{icfg_cfginit};
	$CONFIGFILE = $P{icfg_cfgfile};
	eval('require "$CONFIGFILE";');
	$cfgerror = $@ if $@;
}

# init [%key_words%]
$skin->{'SCRIPTURL'} = 'config.cgi';
$skin->{'CFGFILE'} = $CONFIGFILE;
$skin->{'CFGINIT'} = $CONFIGINIT;

print $skin->Template('config_header');
print $skin->Template('page_section', "$lang{'cfg_file_selected'} <i>$CONFIGFILE</i>; <i>$CONFIGINIT</i>");
print $skin->Template('page_error', "$lang{'cfg_damaged_or_no_file'} : $cfgerror") if $cfgerror and !$P{'icfg_act'};
print $skin->Template('page_action', $lang{'load_def_values'}) if $P{'icfg_act'} eq 'loaddefault';

# read config init file
eval(q{	use IConfig;
				$cfg = new IConfig($CONFIGINIT);
				$cfg->{'cfgparse'} = 1 if !$cfgerror;
				$cfg->{'cfgparse'} = 0 if $P{'icfg_act'} eq 'loaddefault';
				$cfg->LoadConfig(); 
			});
$@?($iconfigerror = $@):($iconfigerror = $cfg->{'error'});

# cfg module loaded?
if ($iconfigerror)
{
	print $skin->Template('page_error', $iconfigerror)
}
# save file?
elsif ($P{'icfg_act'} eq 'savetext')
{
	print $skin->Template('page_action', $lang{'save_cfg_file'});
	open(FILE, ">$CONFIGFILE") || print $skin->Template('page_error', "$lang{'can_not_write'} $CONFIGFILE : $!");
	binmode('FILE'); print FILE $P{'icfg_filecontent'}; close FILE;
	print $skin->Template('config_reload');
}
elsif ($P{'icfg_act'} eq 'saveconfig')
{
	print $skin->Template('page_action', $lang{'save_cfg_file'});
	open(FILE, ">$CONFIGFILE") || print $skin->Template('page_error', "$lang{'can_not_write'} $CONFIGFILE : $!");
	binmode('FILE');
	my @hidden_blocks = ();
	foreach $pname(keys(%P))
	{
		push(@hidden_blocks, $P{$pname}) if $pname =~ '^icfg_hidden_block';
		next if $pname =~ '^icfg_';
		#$P{$pname} =~ s/\n/\\n/g;
		$P{$pname} =~ s/\0/$JOINMULTIPLEBY/g;
		# variable, array or hash?
		my $var = '$';
		$var = $P{"icfg_var_$pname"} if $P{"icfg_var_$pname"}; $var =~ s/\0.*$//;
		# redefine $quoteby if need. delete possible multiple values
		my $quoteby = $QUOTEBY;
		$quoteby = $P{"icfg_quote_$pname"} if $P{"icfg_quote_$pname"}; $quoteby =~ s/\0.*$//;
		print FILE "$var$pname = $quoteby\{$P{$pname}\};\n";
	}
	grep(print(FILE "\n$_\n"), @hidden_blocks);
	print FILE "\n1;\n";
	close FILE;
	print $skin->Template('config_reload');
}
elsif ($P{'icfg_act'} eq 'viewtext' and !$cfg->{'error'})
{
	$filecontent = '';
	open(IN, $CONFIGFILE) || print $skin->Template('page_error', "$lang{'can_not_open'} $CONFIGFILE : $!");
	binmode('IN'); grep ($filecontent .= $_, <IN>); close IN;
	$filecontent =~ s'&'&#38;'g;
	$filecontent =~ s'<'&#60;'g;
	$filecontent =~ s'>'&#62;'g;
	print $skin->Template('config_textmode', $filecontent);
}
else
{
	print $skin->Template('page_attention', $lang{'init_values_load_warning'}) if $cfgerror;
	foreach $section(sort keys %{$cfg->{'config'}})
	{
		$formcontent .= $skin->Template('config_section', $section);
		foreach $subsection(sort keys %{$cfg->{'config'}->{$section}})
		{
			if ($subsection =~ 'ICFG_HIDDEN_BLOCK')
			{
				$formcontent .= qq{<div style="display:none;">$cfg->{'config'}{$section}{$subsection}{'formelement'}</div>};
			}
			else
			{
				$formcontent .= $skin->Template('config_formelement', $cfg->{'config'}{$section}{$subsection}{'desc'}, $subsection, $cfg->{'config'}{$section}{$subsection}{'formelement'});
			}
		}
	}
	print $skin->Template('config_easymode', $formcontent);
}

print $skin->Template('page_footer');

