#!/usr/bin/perl
#!/usr/bin/perl -I/directory/where/preinit.pm/file/is/located
# indexsoft Site-UP
# (c) indexsoft 2001-2004
# http://www.indexsoft.com

require "preinit.pm";
require "$CONFIGFILE";
require "subrouts.pm";
require "initvars.pm";

print qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\nPragma: no-cache\nCache-Control: no-cache\n\n};
if ($skinerror) { print $skinerror; exit; }

print $skin->Template('page_header');
print $skin->Template('page_tips') if $SHOWTIPS;

if ($P{'mask'})
{
	print $skin->Template('page_action', "$lang{'search_with_mask'} $P{'mask'} $lang{'in_directory'} $CURDIR");
	@dirs = &FindDirs($CURDIR);
	foreach $dir(@dirs)
	{
		my $files;
		opendir (DIR, $dir);
		while ($file = readdir(DIR))
		{
			if (!-d "$dir$DIRSEPARATOR$file" and ($file =~ /$P{'mask'}/i) and $file ne '.' and $file ne '..')
			{
				($filedate, $filesize, $fileurl, $filemode, $slink) = &FileInfo("$dir$DIRSEPARATOR$file");
				$slink?($slink=$skin->Template('ls_symlink', $slink)):{$slink=''};
				$direscaped = &EscapeChars($dir);
				if (grep($file =~ /\.$_$/i , split(/\,/, "$TEXTFILES,$HTMLFILES"))) { $filename = $skin->Template('search_edit', $file, $dir) }
				elsif (grep($file =~ /\.$_$/i , split(/\,/, "$ARCHFILES"))) { $filename = $skin->Template('search_archive', $file, $direscaped) }
				elsif (grep($file =~ /\.$_$/i , split(/\,/, "$XMLFILES"))) { $filename = $skin->Template('search_xml', $file, $dir) }
				else { $filename = $file; }
				$filesize = $skin->Template('search_download', $file, $dir, $filesize);
				$filemode = $skin->Template('search_execute', $file, $direscaped, $filemode) if ($filemode =~ '7');
				$files .= $skin->Template('search_file_found', $fileurl, $filename, $slink, &TextDateTime($filedate), $filemode, $filesize);
			}
		}
		closedir(DIR);
		if ($files) { print $skin->Template('search_files_found', $dir, $files); }
		elsif ($dir =~ /$P{'mask'}/i) { print $skin->Template('search_dir_found', $dir); }
	}
}

print $skin->Template('page_section', $lang{'search_with_mask'});
print $skin->Template('search_form', $P{'mask'});
print $skin->Template('page_footer');

sub FindDirs
{
	my ($dir) = @_;
	my ($file, @dirs) = ();
	push (@dirs, $dir);
	local *DIR;
	opendir (DIR, $dir);
	while ($file = readdir(DIR))
	{
		push (@dirs, &FindDirs("$dir$DIRSEPARATOR$file")) if ((-d "$dir$DIRSEPARATOR$file") and $file ne '.' and $file ne '..');
	}
	closedir(DIR);
	return @dirs;
}
